// Analizator.cs - Klasa statistickog analizatora.

namespace Statistika {
  // Delegat koji moze da sadrzi metode ciji se potpisi
  // poklapaju s potpisom delegata.
  public delegate void Rukovalac (double broj);

  public class Analizator {

    // Dogadjaj "napravljen je nov uzorak"
    // koji je tipa navedenog delegata.
    public event Rukovalac NovUzorak;

    public void Radi (ISlucajan sluc, int n) {
      for (int i=0; i<n; i++) {
        double broj = sluc.SlucBroj ();

        // Dojava dogadjaja registrovanim osluskivacima
        // pozivanjem metoda u njihovim delegatima
        // (null - nije registrovan nijedan osluskivac).
        if (NovUzorak != null) NovUzorak (broj);
      }
    }
  }
}