// Casovnik.cs - Klasa aktivnih casovnika.

namespace Uredjivanje {
  using System.Threading;

  public class Casovnik {
    private int dt;                        // Interval ispisivanja.
    private char zn;                       // Ispisivani znak.
    private Thread nit;                    // Nit koja radi.
    private bool radi = false;             // Da li treba da radi?
    private bool kraj = false;             // Da li treba da se zavrsi?

    public Casovnik (int dt, char zn) {    // Inicijalizacija.
      this.dt = dt; this.zn = zn;
      (nit = new Thread (new ThreadStart (rad))).Start ();
    }
    private void rad () {                  // Sadrzaj niti.
      try {
        while (! kraj) {
          if (! radi) lock (this) { Monitor.Wait (this); }
          Thread.Sleep (dt);
          System.Console.Write (zn);
        }
      } catch (ThreadInterruptedException g) {}
    }
    public void Stani () { radi = false; } // Privremeno zaustavljanje.

    public void Kreni () {                 // Nastavak rada.
      lock (this) {
        radi = true; Monitor.Pulse (this); 
      }
    }
    public void Zavrsi () {                // Zavrsetak niti.
      kraj = true; nit.Interrupt ();
    }
  }
}