// Izvestac.cs - Klasa aktivnih izvestaca.

namespace Skladista {
  using System.Threading;
  using System;

  public class Izvestac: IAkter {
    private static int ukId = 0; // Poslednje korisceni identifikator.
    private int id = ++ukId;     // Identifikator izvestaca.
    private Skladiste skladiste; // Pridruzeno skladiste.
    private int perioda;         // Perioda izvestavanja.
    private Thread nit;          // Nit koja radi.
    private bool kraj = false;   // Da li treba da se zavrsi?

    public Izvestac (Skladiste sklad, int per) { // Inicijalizacija.
      perioda = per; skladiste = sklad;
      nit = new Thread (new ThreadStart (radi));
    }
    public Izvestac (Skladiste sklad): this (sklad, 5000) {}
  
    public void Pocni () { nit.Start (); }       // Pokretanje niti.

    private void radi () {                       // Sadrzaj niti.
      Console.WriteLine ("Izvest " + id + " krenuo");
      try {
        while (! kraj) {
          Thread.Sleep (perioda);
          Console.WriteLine ("Izvest " + id + " [" + skladiste + "]");
        }
      } catch (ThreadInterruptedException g) {}
      Console.WriteLine ("Izvest " + id + " zavrsio");
    }
    public void Zavrsi () {                      // Zavrsetak niti.
      kraj = true; nit.Interrupt ();
    }
  }
}