// Kanta.cs - Klasa kanti.

public class Kanta: Valjak {
                    
  private double puno;                             // Napunjeni deo.

  public Kanta (double rr, double hh, double pp)   // Inicijalizacija
      : base (rr,hh) { puno = pp<=V ? pp : V; }

  public Kanta (double rr, double hh)              //   (prazna kanta).
      : this (rr, hh, 0) {}

  public double Ima { get { return puno; } }       // Koliko ima tecnosti?

  public double Fali { get { return V - puno; } }  // Koliko tecnosti fali?

  public bool Puna { get { return puno == V; } }   // Da li je puna?

  public bool Prazna { get { return puno == 0; } } // Da li je prazna?

  public Kanta Dolij (double dopuna) {             // Dolivanje.
    puno = (puno+dopuna <= V) ? puno+dopuna : V;
    return this;
  }
  public Kanta Odlij (double odliv) {              // Odlivanje.
    if (puno-odliv > 0) puno -= odliv; else puno = 0;
    return this;
  }
  public Kanta Presipaj (Kanta k) {                // Presipanje.
    if (this != k) {
      double prazno = V - puno;
      if (prazno >= k.puno) { puno += k.puno; k.puno = 0; }
      else { puno = V; k.puno -= prazno; }
    }
    return this;
  }
  public override string  ToString () {            // Tekstualni opis.
      return '{' + base.ToString() + ',' + puno + '}';
  }
}