// LinijeT.cs - Ispitivanje klasa linija u ravni.

using System;
using Linije;
using Usluge;

public class LinijeT {

  private static Linija citaj() {                 // Citanje jedne linije.
    Console.Write ("Vrsta (D, I, P)? ");
    char vrs = Citaj.Char ();
    switch (vrs) {
      case 'd': case 'D': {
        Console.Write("A? ");
        double xA = Citaj.Double (), yA = Citaj.Double ();
        Console.Write("B? ");
        double xB = Citaj.Double (), yB = Citaj.Double ();
        return new Duz (new Tacka (xA, yA), new Tacka (xB, yB));
      }
      case 'i': case 'I':
      case 'p': case 'P': {
        Console.Write("Broj temena? ");
        Tacka[] niz = new Tacka [Citaj.Int()];
        for (int i=0; i<niz.Length; i++) {
          Console.Write(i+1 + ". teme? ");
          double x = Citaj.Double (), y = Citaj.Double ();
          niz[i] = new Tacka (x, y);
        }
        return (vrs=='i' || vrs=='I') ? new Izlomljena (niz)
                                      : new Poligon    (niz);
      }
      default: return null;
    }
  }

  static void Main (string[] vpar) {              // Glavna funkcija.
    Linija[] niz = new Linija [int.Parse (vpar[0])];
    for (int i=0; i<niz.Length; ) {
      Linija lin = citaj ();
      if (lin != null) niz[i++] = lin;
        else Console.WriteLine ("*** Nepoznata vrsta linije!");
    }
    Console.WriteLine ("\nProcitano:");
    double max = niz[0].Duzina; int imax = 0;
    for (int i=0; i<niz.Length; i++) {
      double d = niz[i].Duzina;
      Console.WriteLine (niz[i] + " d=" + d);
      if (d > max) { max = d; imax = i; }
    }
    Console.WriteLine ("\nNajduza: " + niz[imax]);
  }
}