// Lista1.cs - Klasa listi objekata.

namespace Liste {
  using System; using System.Text;

  public class Lista1 {

    private Elem prvi, posl;            // Pocetak i kraj liste.

    protected class Elem {              // Element liste objekata:
      internal object obj;              // - sadrzani objekat,
      internal Elem pret, sled;         // - prethodni i sledeci element,
      internal Elem (object o, Elem p, Elem s) // - konstruktor.
        { obj = o; pret = p; sled = s; }
    }

    public Lista1 Dodaj (object obj) {    // Dodavanje objekta na kraj liste.
      Elem novi = new Elem (obj, posl, null);
      if (prvi == null) prvi = novi; else posl.sled = novi;
      posl = novi;
      return this;
    }

    public Lista1 Izbaci (object obj) {   // Izbacivanje objekta iz liste.
      Elem tek = prvi; while (tek!=null && tek.obj!=obj) tek=tek.sled;
      if (tek == null) throw new GLstNemaObj (obj);
      izbaci (tek);
      return this;
    }

    private void izbaci (Elem e) {       // Izbacivanje elementa.
      if (e.pret != null) e.pret.sled = e.sled;
      else prvi = e.sled;
      if (e.sled != null) e.sled.pret = e.pret;
      else posl = e.pret;
    }

    protected Elem tek;                  // Tekuci element liste.

    public Lista1 NaPrvi ()               // Pomeranje na prvi element.
      { tek = prvi; return this;}

    public bool ImaTek () { return tek != null; } // Ima li tekuceg?

    public Lista1 NaSledeci () {          // Pomeranje na sledeci element.
      if (ImaTek ()) tek = tek.sled;
      return this;
    }

    public object DohvatiTek () {        // Dohvatanje tekuceg objekta.
      if (! ImaTek()) throw new GLstNemaTek (); 
      return tek.obj;
    }

    public object IzvadiTek () {         // Vadjenje tekuceg objekta.
      if (! ImaTek()) throw new GLstNemaTek ();
      object obj = tek.obj; izbaci (tek); tek = tek.sled;
      return obj;
    }

    public Lista1 Isprazni ()             // Praznjenje liste.
      { prvi = posl = tek = null; return this; }

    public override string ToString () { // Tekstualni opis.
      StringBuilder s = new StringBuilder ('<');
      for (Elem tek=prvi; tek!=null; tek=tek.sled) {
        if (tek != prvi) s.Append (" # ");
        s.Append (tek.obj);
      }
      return s.Append ('>').ToString ();
    }
  }
}