// Lista2.cs - Klasa listi s iteratorom.

namespace Liste {
  using System.Collections;

  public class Lista2: Lista1, IEnumerable {
    public IEnumerator GetEnumerator () {      // Stvaranje iteratora.
      return new Iterator (this);
    }

    private void ponistiTek () { tek = null; } // Ponistavanje tekuceg.

    private class Iterator: IEnumerator {      // Klasa iteratora:
      private Lista1 lst;                       // - pridruzena lista,
      private bool prvi = true;                // - indikator pocetka,

      internal Iterator (Lista2 lst)           // - konstruktor,
        { this.lst = lst; lst.ponistiTek (); }

      public void Reset () { prvi = true; }    // - postavljanje na pocetak,

      public bool MoveNext () {                // - pomeranje na sledeci,
        if (prvi) { lst.NaPrvi(); prvi = false; }
          else lst.NaSledeci ();
        return lst.ImaTek ();
      }

      public object Current {                  // - dohvatanje tekuceg.
        get { return lst.DohvatiTek (); }
      }
    }
  }
}