// MetodaPodele.cs - Klasa za uredjivanje metodom podele
//                   (Quick Sort).

namespace Uredjivaci {
  using Usluge;

  public class MetodaPodele: IUredjivac {

    public void Uredi (IUporediv[] niz) {    // Uredjivanje niza.
        uredi (niz, 0, niz.Length-1); }

    private void uredi (IUporediv[] a, int p, int q) {
      if (q > p) {
        int i = p-1, j = q;
        while (true) {
          do i++; while (a[i].Ispred (a[q]));
          do j--; while (j>=0 && a[q].Ispred (a[j]));
          if (i >= j) break;
          IUporediv b = a[i]; a[i] = a[j]; a[j] = b;
        }
        IUporediv c = a[i]; a[i] = a[q]; a[q] = c;
        uredi (a, p, i-1); uredi (a, i+1, q);
      }
    }

    public override string ToString ()      // Naziv algoritma.
      { return "Metoda podele"; }
  }
}