// NizZnakova.cs - Klasa nizova uporedivih znakova.

namespace Uredjivanje {
  using System.Text;

  public class NizZnakova {
    private Znak[] niz;                     // Sadrzani niz.
    private System.Random sluc =            // Generator slucajnih brojeva.
              new System.Random ();

    public NizZnakova (int n) {                       // Inicijalizacija.
      niz = new Znak [n]; Puni ();
    }
                                                      // Popunjavanje niza:
    public void Puni (Znak p, Znak q) {               // - zadatim opsegom,
      if (q.Manji (p)) throw new GOpseg ();
      for (int i=0; i<niz.Length; i++)
        niz[i] = new Znak ((char)(sluc.Next (p.Zn, q.Zn+1)));
    }
    public void Puni () {                             // - podrazumevanim
      Puni (new Znak('a'), new Znak ('z'));           //   opsegom.
    }
    public void Uredi (Uredjivac u) {                 // Uredjivanje niza.
      u.Uredi (niz); }

    public override string ToString () {              // Tekstualni opis.
      StringBuilder s = new StringBuilder ();
      for (int i=0; i<niz.Length; i++) {
        s.Append (niz[i].Zn);
        if (i%50==49 || i==niz.Length-1)
          s.Append ('\n');
      }
      return s.ToString ();
    }
  }
}