// Poli.cs - Klasa polinoma.

using System;

public class Poli {                             // KLASA POLINOMA:
  private double[] a;                           // Niz koeficijenata.

  public Poli (int n) { a = new double [n+1]; } // Konstruktori.
  public Poli (double[] p) { a = p; }

  public int Red { get { return a.Length-1; } } // Dohvatanje reda.

  public double this[int i] {                   // Pristup koeficijentu:
    get { return a[i]; }                        // - uzimanje,
    set { a[i] = value; }                       // - postavljanje.
  }

  public double P (double x) {                  // Vrednost polinoma.
    double s = 0;
    for (int i=a.Length-1; i>=0;  s=s*x+a[i--]);
    return s;
  }

  public override string ToString () {          // Tekstualni opis.
    string s = "P[";
    for (int i=a.Length-1; i>=0; i--) {
      s += a[i]; if (i>0) s += ' '; }
    return s + ']';
  }
}