// Potrosac.cs - Klasa aktivnih potrosaca.

namespace Skladista {
  using System.Threading;
  using System;

  public class Potrosac: IAkter {

    private static int ukId = 0;    // Poslednje korisceni identifikator.
    private int id = ++ukId;        // Identifikator proizvodjaca.
    private Skladiste skladiste;    // Pridruzeno skladiste.
    private int minVreme, maxVreme; // Najkrace i najduze vreme proizvodnje.
    private Thread nit;             // Nit koja radi.
    private bool kraj = false;      // Da li treba da se zavrsi?
    private Random sluc;            // Generator slucajnih brojeva.

    public Potrosac                              // Inicijalizacija.
      (Skladiste sklad, int minVr, int maxVr) { 
      minVreme = minVr; maxVreme = maxVr; 
      skladiste = sklad;
      nit = new Thread (new ThreadStart (radi));
      sluc = new Random ();
    }
    public Potrosac (Skladiste sklad)
      : this (sklad, 1000, 2000) {}

    public void Pocni () { nit.Start (); }       // Pokretanje niti.

    private void radi () {                       // Sadrzaj niti.
      Console.WriteLine ("Potros " + id + " krenuo");
      try {
        while (! kraj) {
          int vredn = skladiste.Uzmi ();
          Console.WriteLine ("Potros " + id + " uzeo    " + vredn);
          Thread.Sleep (sluc.Next (minVreme, maxVreme));
        }
      } catch (ThreadInterruptedException g) {}
      Console.WriteLine ("Potros " + id + " zavrsio");
    }
    public void Zavrsi () {                      // Zavrsetak niti.
      kraj = true; nit.Interrupt ();
    }
  }
}