// Predmet2.cs - Apstraktna klasa predmeta.

using System;

namespace Predmeti2 {
  public abstract class Predmet: ICloneable {

    private static int ukId;    // Poslednje korisceni identifikator.
    private int id = ++ ukId;   // Identifikator predmeta.

    public int Id { get { return id; } }   // Dohvatanje identifikatora.

    public abstract double V { get; }      // Zapremina.

    public abstract double Q { get; }      // Tezina.

    public virtual object Clone () {             // Stvaranje kopije:
      Predmet p = (Predmet)MemberwiseClone ();   // - plitka kopija,
      p.id = ++ukId;                             // - dorada kopije.
      return p;
    }
    public string Vrsta {                  // Dohvatanje vrste predmeta.
      get { return GetType ().Name; }
    }
    public override string ToString () {   // Tekstualni opis.
      return Id + " " + Vrsta;
    }
  }
}