// Proizvodjac.cs - Klasa aktivnih proizvodjaca.

namespace Skladista {
  using System.Threading;
  using System;

  public class Proizvodjac: IAkter {

    private static int ukId = 0;    // Poslednje korisceni identifikator.
    private int id = ++ukId;        // Identifikator proizvodjaca.
    private Skladiste skladiste;    // Pridruzeno skladiste.
    private int minVreme, maxVreme; // Najkrace i najduze vreme proizvodnje.
    private int broj;               // Poslednje proizvedeni podatak.
    private Thread nit;             // Nit koja radi.
    private bool kraj = false;      // Da li treba da se zavrsi?
    private Random sluc;            // Generator slucajnih brojeva.


    public Proizvodjac                           // Inicijalizacija.
      (Skladiste sklad, int minVr, int maxVr) { 
      minVreme = minVr; maxVreme = maxVr; 
      skladiste = sklad;
      nit = new Thread (new ThreadStart (radi));
      sluc = new Random ();
    }
    public Proizvodjac (Skladiste sklad)
      : this (sklad, 1000, 2000) {}

    public void Pocni () { nit.Start (); }       // Pokretanje niti.

    private void radi () {                       // Sadrzaj niti.
      Console.WriteLine ("Proizv " + id + " krenuo");
      try {
        while (! kraj) {
          Thread.Sleep (sluc.Next (minVreme, maxVreme));
          int vredn = id*1000 + ++broj; 
          Console.WriteLine ("Proizv " + id + " stavlja " + vredn);
          skladiste.Stavi (vredn);
        }
      } catch (ThreadInterruptedException g) {}
      Console.WriteLine ("Proizv " + id + " zavrsio");
    }
    public void Zavrsi () {                      // Zavrsetak niti.
      kraj = true; nit.Interrupt ();
    }
  }
}