// Sklop.cs - Klasa sklopova predmeta.

using System.Text;

namespace Predmeti2 {
  public class Sklop: Predmet {
  
    private Predmet[] niz = new Predmet [3];      // Niz sadrzanih predmeta.
    private int duz = 0;                          // Broj popunjenih mesta.

    public Sklop Dodaj (Predmet p) {              // Dodavanje predmeta.
      if (duz == niz.Length) {
        Predmet[] pom = new Predmet [duz+3];
        for (int i=0; i<duz; pom[i]=niz[i++]);
        niz = pom;
      }
      niz[duz++] = p;
      return this;
    }
    public Predmet Dohvati (int ind) {            // Dohvatanje predmeta.
      return (ind>=0 && ind<duz) ? niz[ind] : null;
    }
    public override sealed double V {             // Zapremina.
      get {
        double v = 0;
        for (int i=0; i<duz; v+=niz[i++].V);
        return v;
      }
    }
    public override sealed double Q  {            // Tezina.
      get {
        double q = 0;
        for (int i=0; i<duz; q+=niz[i++].Q);
        return q;
      }
    }
    public override object Clone () {             // Stvaranje kopije:
      Sklop s = (Sklop)base.Clone ();             // - plitka kopija,
      s.niz = new Predmet [niz.Length];           // - duboka kopija.
      for (int i=0; i<duz; s.niz[i]=(Predmet)niz[i++].Clone());
      return s;
    }

    private static int nivo = 0;                  // Nivo uklapanja predmeta.

    private static void uvuci (StringBuilder s) { // Uvlacenje uklopljenih
      for (int i=0; i<nivo; i++) s.Append ("  "); //   predmeta u tekstu-
    }                                             //   alnom opisu sklopa.

    public override string ToString () {          // Tekstualni opis.
      StringBuilder s = new StringBuilder ();
      s.Append (base.ToString ()).Append (" {\n");
      nivo++;
      for (int i=0; i<duz; i++) {
        uvuci (s); s.Append (niz[i]).Append ('\n');
      }
      nivo--;
      uvuci (s); return s.Append ('}').ToString ();
    }
  }
}