// StatistikaT.cs - Ispitivanje klasa generatora slucajnih brojeva.

using System; using Statistika;

public class StatistikaT {
  static IPokazatelj[] pokaz = { // Sastavljaci statistickih pokazatelja.
    new Brojac(), new Minimum (), new Maximum (),
    new Srednja(), new Devijacija ()
  };

  static void Main () {                // Glavna funkcija.
    // Generator slucajnih brojeva.
    ISlucajan gen = new Uniforman ();

    // Statisticki analizator.
    Analizator analizator = new Analizator ();

    foreach (IPokazatelj pok in pokaz)
      // Registrovanje osluskivaca dodajuci dogadjaju delegate
      // inicijalizovanim metodama odgovarajuceg potpisa.
      analizator.NovUzorak += new Rukovalac (pok.Azuriraj);

    // Obrada koja generise dogadjaje.
    analizator.Radi (gen, 10000);

    // Prikazivanje rezultata.
    foreach (IPokazatelj pok in pokaz)
      Console.WriteLine (pok + ": " + pok.Uzmi);
  }
}