// UredjivaciT.cs - Ispitivanje klasa za uredjivanje nizova.

using Uredjivaci;
using Usluge;
using System;
//import java.util.Random;

public class UredjivaciT {

  // Niz za objekte algoritama uredjivanja.
  private static IUredjivac[] metode = {
    new MetodaIzbora (),       new MetodaIzbora2 (),
    new MetodaUmetanja (),     new MetodaUmetanja2 (),
    new MetodaZameneSuseda (), new MetodaPodele ()
  };

  // Ispisivanje niza.
  private static void pisi (string nasl, IUporediv[] niz) {
    Console.WriteLine ("\n" + nasl + "\n");
    for (int i=0; i<niz.Length; i++) {
      Console.Write (niz[i] + "\t");
      if (i%8==7 || i==niz.Length-1) Console.WriteLine ();
    }
  }

  // Glavna funkcija.
  static void Main () {
    IUredjivac metoda = metode[0];
    IUporediv[] niz = new Ceo [1000];
    Random sluc = new Random ();
    bool kraj = false;
    while (! kraj) { // Ispisivanje menija:
      Console.Write (
        "\n1. Zadavanje duzine niza\n"                     +
          "2. Postavljanje generatora slucajnih brojeva\n" +
          "3. Izbor algoritma\n"                           +
          "4. Primena algoritma\n"                         +
          "0. Kraj programa\n"                             +
          "Vas izbor? "
      );
      switch (Citaj.Int ()) {

        case 1: // Zadavanje duzine niza:
          Console.Write ("Duzina niza? ");
          int d = Citaj.Int ();
          if (d > 0) niz = new Ceo [d];
            else Console.WriteLine ("*** Nedozvoljena duzina!");
          break;

        case 2: // Postavljanje generatora slucajnih brojeva:
          Console.Write ("Pocetna vrednost generatora? ");
          sluc = new Random (Citaj.Int ());
          break;

        case 3: // Izbor algoritma:
          Console.WriteLine ();
          for (int i=0; i<metode.Length; i++)
            Console.WriteLine (i+1 + ". " + metode[i]);
          Console.Write ("Vas izbor? ");
          int izbor = Citaj.Int ();
          if (izbor>0 && izbor<=metode.Length)
            metoda = metode [izbor-1];
            else Console.WriteLine ("*** Nedozvoljen izbor!");
          break;

        case 4: // Primena algoritma:
          for (int i=0; i<niz.Length; i++)
            niz[i] = new Ceo ((int)(sluc.NextDouble() * 10000));
          if (niz.Length <= 100) pisi ("Pocetni niz:", niz);
          long t1 = DateTime.Now.Ticks;   // 1 tik = 100 ns
          metoda.Uredi (niz);
          long t2 = DateTime.Now.Ticks;
          if (niz.Length <= 100)
            pisi ("Uredjeni niz:", niz);
          else
            Console.WriteLine (metoda + " (" + niz.Length + "): " +
                                ((t2-t1)*1e-7).ToString("f3"));
          break;

        case 0: // Kraj programa:
          kraj = true; break;

        default: // Pogresan izbor:
          Console.WriteLine ("*** Nedozvoljen izbor!");
          break;
      }
    }
  }
}