// Verizan.cs - Klasa veriznih razlomaka.

namespace Verizni {

  public class Verizan {

    double[] a;                                    // Koeficijenti razlomka.

    public Verizan (int n) { a = new double [n]; } // Inicijalizacija.

    public double this[int i] {                    // Pristup koeficijentu:
      set {                                        // - postavljanje.
        if (i<0 || i>=a.Length) throw new GVerInd(a.Length, i);
        a[i] = value;
      }
    }
    public double Vr (double x) {                  // Vrednost razlomka.
      double s = 0;
      for (int i=a.Length-1; i>=0; i--) {
        if (x + s == 0) throw new GVerNula ();
        s = a[i] / (x + s);
      }
      return s;
    }
    public override string ToString () {           // Tekstualni opis.
      string s = "Veriz[";
      for (int i=0; i<a.Length; i++) {
        if (i > 0) s += ",";
        s += a[i];
      }
      return s + "]";
    }
  }
}